Welcome to Subscribe On Youtube

Formatted question description: https://leetcode.ca/all/760.html

760. Find Anagram Mappings (Easy)

Given two lists Aand B, and B is an anagram of A. B is an anagram of A means B is made by randomizing the order of the elements in A.

We want to find an index mapping P, from A to B. A mapping P[i] = j means the ith element in A appears in B at index j.

These lists A and B may contain duplicates. If there are multiple answers, output any of them.

For example, given

A = [12, 28, 46, 32, 50]
B = [50, 12, 32, 46, 28]

We should return

[1, 4, 3, 2, 0]

as P[0] = 1 because the 0th element of A appears at B[1], and P[1] = 4 because the 1st element of A appears at B[4], and so on.

Note:

  1. A, B have equal lengths in range [1, 100].
  2. A[i], B[i] are integers in range [0, 10^5].

Companies:
Google

Related Topics:
Hash Table

Solution 1.

  • class Solution {
        public int[] anagramMappings(int[] A, int[] B) {
            int length = A.length;
            List<Integer> listB = new ArrayList<Integer>();
            for (int i = 0; i < length; i++)
                listB.add(B[i]);
            int[] anagram = new int[length];
            for (int i = 0; i < length; i++) {
                int num = A[i];
                int index = listB.indexOf(num);
                anagram[i] = index;
                listB.set(index, -1);
            }
            return anagram;
        }
    }
    
    ############
    
    class Solution {
        public int[] anagramMappings(int[] nums1, int[] nums2) {
            Map<Integer, Set<Integer>> map = new HashMap<>();
            for (int i = 0; i < nums2.length; ++i) {
                map.computeIfAbsent(nums2[i], k -> new HashSet<>()).add(i);
            }
            int[] res = new int[nums1.length];
            for (int i = 0; i < nums1.length; ++i) {
                int idx = map.get(nums1[i]).iterator().next();
                res[i] = idx;
                map.get(nums1[i]).remove(idx);
            }
            return res;
        }
    }
    
  • // OJ: https://leetcode.com/problems/find-anagram-mappings/
    // Time: O(N)
    // Space: O(N)
    class Solution {
    public:
        vector<int> anagramMappings(vector<int>& A, vector<int>& B) {
            unordered_map<int, int> m;
            for (int i = 0; i < B.size(); ++i) m[B[i]] = i;
            vector<int> ans;
            for (int n : A) ans.push_back(m[n]);
            return ans;
        }
    };
    
  • class Solution:
        def anagramMappings(self, nums1: List[int], nums2: List[int]) -> List[int]:
            mapper = defaultdict(set)
            for i, num in enumerate(nums2):
                mapper[num].add(i)
            return [mapper[num].pop() for num in nums1]
    
    ############
    
    class Solution:
        def anagramMappings(self, A, B):
            """
            :type A: List[int]
            :type B: List[int]
            :rtype: List[int]
            """
            answer = []
            for a in A:
                for i,b in enumerate(B):
                    if a == b:
                        answer.append(i)
                        break
            return answer
    

All Problems

All Solutions